Create a Sudoku Solver In Java In 20 Minutes - Full Tutorial

SdĂ­let
VloĆŸit
  • čas pƙidĂĄn 12. 05. 2021
  • Complete Java course: codingwithjohn.thinkific.com/...
    Source code here: www.codingwithjohn.com/sudoku...
    Let's create a Sudoku solver in Java!
    Sudoku is a logic game, where you fill in numbers from 1-9 in a 9x9 grid. In Sudoku, each row, column, and 3x3 sub-grid must contain all numbers from 1-9.
    Solving Sudoku in Java seems like it could be complicated - and some of it certainly is! But I'll break down the Java program for solving Sudoku into more simple pieces that we'll code together.
    Learn or improve your Java by watching it being coded live!
    Hi, I'm John! I'm a Lead Java Software Engineer and I've been in the programming industry for more than a decade. I love sharing what I've learned over the years in a way that's understandable for all levels of Java developers.
    Let me know what else you'd like to see!
    Links to any stuff in this description are affiliate links, so if you buy a product through those links I may earn a small commission.
    📕 THE best book to learn Java, Effective Java by Joshua Bloch
    amzn.to/36AfdUu
    📕 One of my favorite programming books, Clean Code by Robert Martin
    amzn.to/3GTPVhf
    🎧 Or get the audio version of Clean Code for FREE here with an Audible free trial
    www.audibletrial.com/johnclean...
    đŸ–„ïžStanding desk brand I use for recording (get a code for $30 off through this link!)
    bit.ly/3QPNGko
    đŸ“čPhone I use for recording:
    amzn.to/3HepYJu
    đŸŽ™ïžMicrophone I use (classy, I know):
    amzn.to/3AYGdbz
    Donate with PayPal (Thank you so much!)
    www.paypal.com/donate/?hosted...
    ☕Complete Java course:
    codingwithjohn.thinkific.com/...
    codingwithjohn.com

Komentáƙe • 344

  • @19joni69
    @19joni69 Pƙed 2 lety +51

    Making a sudoku solver was actually the very first project I programmed once I'd learned the basics. This takes me back.

    • @yahia1355
      @yahia1355 Pƙed rokem +5

      Wow ! I have been coding for arround 5 years and could'nt come up with a solution!

    • @19joni69
      @19joni69 Pƙed rokem +4

      @@yahia1355 oh I didn't do anything smart. I literally brute forced a solution. Basically going over every single square and trying the first number that works, then if I got to one that had no possible correct number I would go back until the first square that I could have put a different number in and tried the different number. Do that until you can fill every square correctly. Just literally trying every combination until it works. There are much better ways to solve this. But the not so smart solution works.

    • @user-cg4vi4kn4v
      @user-cg4vi4kn4v Pƙed 3 měsĂ­ci

      @@19joni69 đŸ€ŁđŸ€ŁđŸ˜‚

  • @clo-1588
    @clo-1588 Pƙed 2 lety +87

    You're an excellent teacher, John. I find your videos not only extremely helpful, but impressively well-made - and it's not even so much about the format (which is ideal), but the way you teach and the examples you give. You explain things in a logical, progressive way, and you're excellent at providing the right level of exposure. I do wish there were more teachers like you in universities - but then, we might not have you on CZcams ;) Please keep going with these tutorials, you are contributing to the community in a huge way.

  • @stormybear4986
    @stormybear4986 Pƙed 2 lety +7

    This was, legitimately, the most interesting java tutorial I've seen in years! EXCELLENT!!!!!

  • @janekk3397
    @janekk3397 Pƙed rokem +3

    I'm so glad channels like this one exist. It was a part of my project and I would've never figured that out myself...

  • @krishnawadhwani5393
    @krishnawadhwani5393 Pƙed 2 lety +65

    I had recently discovered this channel, haha, and I started to watch your videos on TV Like I am watching some movies or some kind of entertainment, nice videos keep it up, subscribed after watching 2-3 videos

  • @nikhilraov100
    @nikhilraov100 Pƙed 2 lety +2

    This program works perfectly. What a flawless algorithm you have written .

  • @saviobatista9619
    @saviobatista9619 Pƙed 2 lety +1

    Thank you! Amazing video, where I work I tried several times create something to solve our work schedule with some kind of algorithm but always fail, this was just exactly what I needed and hope to solve my needs. Thank you!

  • @navyathamarreddy2807
    @navyathamarreddy2807 Pƙed rokem +1

    very nicely explained John, I saw few other videos as well for Sudoku Solver, but this is amazing!

  • @jagi7976
    @jagi7976 Pƙed rokem +3

    It’s beautiful when something that’s educational is also entertaining

  • @olayiwolaakinnagbe676
    @olayiwolaakinnagbe676 Pƙed rokem

    This is the best video I found online for this problem. You are a great teacher, thank you.

  • @sharadgupta8576
    @sharadgupta8576 Pƙed 2 lety +8

    It was just really awesome and in so nice way u described it's just really wow... M so surprised why just so less likes I have watched couple of videos before but u just explained really understanding with gotcha learn some new concept as well successfully found my final year project as well thanks for making this video... I will surely check out your more videos.. Great job 👍

  • @rajeshg3570
    @rajeshg3570 Pƙed 2 lety +1

    This is excellent .. i simply love the naming conventions of the vars..which makes its easy to read and understand the logic

  • @penguin7863
    @penguin7863 Pƙed rokem +2

    Sir before I watch your video I was a student who was struggling to solve recursion problems for my upcoming test. Now I get the idea about how to backtrack in recursion :) Huge thanks from South Korean student!

  • @Nikolai4567
    @Nikolai4567 Pƙed 2 lety +2

    I didn't think this solution would have an adequate time complexity. Thanks!

  • @michaelkraemerman2009
    @michaelkraemerman2009 Pƙed rokem +1

    This was such a good explanation!!! I feel a lot more confident about implementing this. Also thanks for not acting like this is easy/obvious👏

  • @mdrwsh
    @mdrwsh Pƙed 2 lety +1

    it is amazing to see various algorithms that be used to solve sudoku, i made one but using while loop

  • @francescopiazza4882
    @francescopiazza4882 Pƙed 2 lety

    Great coding John! I got a "Hard Sudoku" solved in a few ms !

  • @prade1
    @prade1 Pƙed rokem +2

    This is exactly what I was looking for to complement my java studies. Projects with step-by-step explained.
    Please, keep it going, unfortunately here on CZcams, everything seems to be only JavaScript or Python. It would be great more projects with OOP.

  • @carlostitlan
    @carlostitlan Pƙed rokem

    Your explanaition is soo cool! You even make feel this stuff is easy.

  • @abdurrouf4159
    @abdurrouf4159 Pƙed 2 lety

    You just nailed it. Mind blowing tutorial, no doubt.

  • @qurdedu4032
    @qurdedu4032 Pƙed rokem +1

    Great explanation and great mini project
    Thank you so much. Looking for more project like this

  • @jhuluan-jyun2594
    @jhuluan-jyun2594 Pƙed 2 lety +1

    No wonder you’re a lead! Very clear sir, thank you

  • @Bury11
    @Bury11 Pƙed 2 lety +4

    cool project :) i'm fairly new to java, i programmed a small snake'ish game, so i understood the 2d array way better then i thought :D keep up the good work!

  • @tonyz2203
    @tonyz2203 Pƙed 2 lety

    OMG, I understand how to solve this complex problem now. Thank you so much!

  • @devforall2006
    @devforall2006 Pƙed 2 lety

    Simply Nailed It, AWESOME EXPLANATION

  • @sigfigronath
    @sigfigronath Pƙed 2 lety +2

    This was really nice, fun and informative!

  • @zimbabwe8189
    @zimbabwe8189 Pƙed 3 lety +1

    Great video, your explanation was pretty clear!

  • @ulyses1018
    @ulyses1018 Pƙed rokem +1

    Great video! Thanks for this kind of tutorials John! :D

  • @PathWars
    @PathWars Pƙed 2 lety

    Awesome, exactly the kind of CZcams channel I wanted:
    Regularly uploaded coding videos.

  • @staceyonuora5329
    @staceyonuora5329 Pƙed 2 lety +2

    Great video, I really enjoyed your explanation. Super thanks, this was very helpful

  • @vivekjj2986
    @vivekjj2986 Pƙed 2 lety

    Thanks so much John. I spent a lot of time searching on youtube for a good tutorial on this. I wish yours was the first video so i could have saved time :(

  • @Garrison86
    @Garrison86 Pƙed 2 lety +1

    Amazing! Thanks for this, this helps me stay engaged in java

  • @JonasKeil
    @JonasKeil Pƙed 2 lety +1

    This tutorial is excellent John.

  • @luigiq6429
    @luigiq6429 Pƙed 3 lety +5

    Great video John. Congrats on 500 subs!

  • @kunalkheeva
    @kunalkheeva Pƙed 2 lety +1

    How did you make it so simple, I always appreciate your content. your content is limited on youtube but whenever I get stuck in any problem and you have a video on that, which means, my last destiny is your video. Thank you

  • @siddhantanand5751
    @siddhantanand5751 Pƙed 2 lety +3

    Hey, John I loved the way you went forward with explaining the video , you made it quite easy to learn the algorithm and fun too, i was curious if we can attach some image recognition tools like OpenCV etc for Java , so that we can scan a sudoku at run time and give an image back? I would love if you could show us how to do this if you like the idea.

  • @joekagerer
    @joekagerer Pƙed rokem

    I wrote a Sudoku solver in 2008 in Javascript, but it didn't quite use full recursion (my mistake) so it wouldn't solve moderately difficult puzzles. Mine includes character recognition of uploaded websuduko puzzles. This week I added "paste from clipboard" so that I didn't have to save/load my puzzle images. Today, following your model I finally got mine solving even the "evil" puzzles. Thank You John for this great lesson. Although now I don't feel that "I wrote the code", my page works and I did right the optical character recognition parts. I don't believe that I can share a link here, but I can try.

  • @jaydoshi5394
    @jaydoshi5394 Pƙed 2 lety

    Watching couple of videos from this channel every day in any order. But still makes sense

  • @footballalliance2412
    @footballalliance2412 Pƙed 3 lety +10

    Hi John, i have learned a lot from your videos. I hope you won't stop making videos in upcoming days, it is really helpful for us.
    I can guarantee you will get a huge subscribers in coming days.

    • @CodingWithJohn
      @CodingWithJohn  Pƙed 3 lety +10

      Thanks! Glad you're getting something out of them. I'll keep making them if people keep watching them!

  • @razvanungureanu8897
    @razvanungureanu8897 Pƙed rokem

    I have reached the part where I didn't find a solution to erase the all the numbers of the board and to retry. I know it needed some recursion, but didn't figure out how. Your explanation was excellent and after reviewing your method, everything makes sense. Thanks and keep it up with these kind of videos!

  • @abidoyevictor2780
    @abidoyevictor2780 Pƙed 3 lety +1

    Well explained!
    Thanks John

  • @northnorth9913
    @northnorth9913 Pƙed 2 lety +3

    I like what you doing, Hope you get the chance to do Dijkstra’s algorithm, Time complexity and a few more interview related.
    I like your explanations

  • @guidopiotrowski7900
    @guidopiotrowski7900 Pƙed 2 lety

    Thanks for the great explanation! Keep it up with the channel!

  • @mira1m198
    @mira1m198 Pƙed 2 lety

    Great explanation, easy to understand, even for beginners :-) Thanks!

  • @mastershonobi110
    @mastershonobi110 Pƙed 2 lety +1

    Gr8 vid. Spent the last 2days working on this really breaking it down. I got a lot outta following and really understanding what’s going on here. Keep them coming
🙌🏿🙌🏿

  • @alzaeem79
    @alzaeem79 Pƙed rokem

    Beautifully well explained, thank you sir.

  • @sritamabanerjee1331
    @sritamabanerjee1331 Pƙed 3 lety

    Loved your explanation..keep it up buddy 😊

  • @josueramirez7247
    @josueramirez7247 Pƙed 2 lety

    In an intro to programming textbook I own, it mentions in the preface that one difference from prior printings is that it removes the sudoku solver example code from the multidimensional arrays chapter because apparently is it too complex at that point.

  • @surajverma-ut4kj
    @surajverma-ut4kj Pƙed rokem

    Just one word for John đŸ™đŸŒ
    Big ThankYou âŁïž

  • @rams2478
    @rams2478 Pƙed 2 lety

    WOW.. you are amazing....clean.. detailed.. explanation.
    Please do Leetcode problems also.. It will help us.

  • @sanchitghai1455
    @sanchitghai1455 Pƙed 2 lety

    I like that you also play binding of issac 🙂.
    As for the program I loved it. It was well made video for beginners and one can't not understand the concept. Keep it up! 👍

  • @amaralensheriff
    @amaralensheriff Pƙed rokem

    As always, thank you John.

  • @kingsuley0581
    @kingsuley0581 Pƙed 9 měsĂ­ci

    Loved this!

  • @javawocky
    @javawocky Pƙed rokem

    Very nice. I do this stuff for fun. Recently did one of those word search generators which you see kids books all the time. Way more interesting to do than you may initially think.

  • @b9944236
    @b9944236 Pƙed 11 měsĂ­ci

    Now I can solve it by myself, thanks a lot.

  • @ponder2406
    @ponder2406 Pƙed 2 lety

    Wow! That’s so cool! This was an awesome video! Very interesting :)

  • @Darya-pu6ik
    @Darya-pu6ik Pƙed 2 lety +1

    its fantastic, i really like the way you teach, its intresting! However, could we do it using DP or is the an NP?

  • @AdamantlyAdams
    @AdamantlyAdams Pƙed 2 lety

    Bro, thank you for teaching. You are the go to guy!

  • @neeldiyora3575
    @neeldiyora3575 Pƙed rokem

    Excellent explanation 👏👏👏

  • @Pennervomland
    @Pennervomland Pƙed 2 lety +4

    I‘d love to see this exact algorithm but more efficient. Knuths Algorithm X for sudoku sounds very interesting and shows a pretty good method for backtracking. I‘m too dumb to understand how to implement it in java but it could be a cool challenge for you.

  • @devoiddude
    @devoiddude Pƙed 2 lety

    Fantastic video and fantastic channel, your videos are great thanks .

  • @mynameispooop
    @mynameispooop Pƙed rokem

    Awesome Tutorial

  • @joedevenski3291
    @joedevenski3291 Pƙed 2 lety

    Fantastic stuff!

  • @obitouchiha7545
    @obitouchiha7545 Pƙed 2 lety

    Wow sir you can explain things very well, let aside being multitasker.

  • @Daniel-iy1ed
    @Daniel-iy1ed Pƙed 2 lety

    That was fantastic. Thanks 🙏

  • @nezetech
    @nezetech Pƙed 2 lety

    Dude, thanks a lot!! You saved me

  • @Gandobilis
    @Gandobilis Pƙed rokem

    Very interesting tutorial!

  • @user-sr7ht8rm6r
    @user-sr7ht8rm6r Pƙed 8 měsĂ­ci

    John, thank you for everything! Could you maybe make a video on backtracking specificaly? That would be awesome! :)

  • @estebanlegare
    @estebanlegare Pƙed rokem

    Really helpful!

  • @JannisAdmek
    @JannisAdmek Pƙed 2 lety +29

    You teaching skills are really impressive, great work! I have one minor point to critique, you hardcoded GRID_SIZE 9 but used 3 as a magic number. You could have computed it once sqrt(GRID_SIZE) or just declared it as a constant.

    • @Michael-se7ny
      @Michael-se7ny Pƙed 2 lety +5

      sqrt(GRID_SIZE) would make no sense at all

    • @JannisAdmek
      @JannisAdmek Pƙed 2 lety +5

      @@Michael-se7ny Really? Doesn't a Sudoku box always have side length of sqrt(GRID_SIZE)? But I guess the really clean way would be to define the sudoku in terms of the BOX_SIZE, since GRID_SIZE has to be square number.
      so a normal sudoku is BOX_SIZE = 3. (GRID_SIZE = BOX_SIZE * BOX_SIZE)

    • @p_varma17
      @p_varma17 Pƙed rokem

      @@JannisAdmek right

  • @RomualdBrunet
    @RomualdBrunet Pƙed 2 lety +4

    Using static methods and passing the board as parameter hurts my brain for some reason
    (vs using the board as an instance of a class)

    • @ae6072
      @ae6072 Pƙed 4 měsĂ­ci

      same! Why doesnt he use the board as an instance? Is there any special reason for this?

  • @manusoftar
    @manusoftar Pƙed 2 lety +1

    I think that those nested for loops on the solve method are unecesary, you could add two additional params to send the current row and column and inside the function you just would need to either add the the rows or to the column depending on what you are doing... yes you will have to put some IF's, but the way you did it I think it will do unnecesary iterations, I mean, the last recursive call on a solvable board will put the needed number but there's nothing that would stop the initial call to the solve method from stopping it's iterations. Actually, on each recursive call it will have to traverse as far as possible on the board until sending back a false or a true if solved. You don't need the algorithm to traverse almost the whole board on each recursive call, you just need it to make a single step on the board instead.

  • @AkhtarReviews
    @AkhtarReviews Pƙed 2 lety

    Loved it! đŸ”„

  • @dunayqudretli3382
    @dunayqudretli3382 Pƙed 2 lety

    Great tutorial !

  • @stephanc7192
    @stephanc7192 Pƙed 2 lety

    You make truly great videos

  • @wombozombo
    @wombozombo Pƙed rokem +2

    Fun way to learn about recursion 👍

  • @buddybuythis3889
    @buddybuythis3889 Pƙed 2 lety

    Wow! Sooo nice and free! Instant sub and hooked. Binge time.

  • @abubakaradamu6278
    @abubakaradamu6278 Pƙed 2 lety

    I think, i just found my best youtuber. Keep up the good work John.

  • @Maddin1989yo
    @Maddin1989yo Pƙed 2 lety +3

    Great and concise explanation! When this video was suggested, I found it hard to believe that this was doable in a beginner friendly way in only 20 minutes, well done!
    I have one suggestion though: If you have the GRID_SIZE as a static final int, the box size (3, as used as a magic number in isNumberInBox(...) and print(...)) should be, too! Probably it should be initialized as the square root of GRID_SIZE, or vice versa.

  • @nagasivakrishna5660
    @nagasivakrishna5660 Pƙed rokem

    wow,next level explanation

  • @sweetysojrani9323
    @sweetysojrani9323 Pƙed 8 dny

    Awesome algorithm. It would be nice, if you could also explain the time complexity of the algorithm in your video.

  • @techtonight882
    @techtonight882 Pƙed 2 lety +28

    I think we can use dynamic programming too, to reduce some of the complexity. We can use a HashMap to store if a number at particular position was a valid placement or not.

    • @kesarscorpio
      @kesarscorpio Pƙed 2 lety +17

      i guess this one is for beginners and that's why he chose this way of doing it

    • @cs0576
      @cs0576 Pƙed 2 lety +10

      But that is dependent on the previous placements. So I do not immediately see how that improves this algorithm.

    • @smrtfasizmu6161
      @smrtfasizmu6161 Pƙed 2 lety

      The argument of the hashmap needs to be both the board and the placement of the number. How does backtracking in your algorithm work? I am not sure how you intended to do it with hashmaps and make the code less complex than what you saw in this video. Can you elaborate further?
      One idea popped up in my mind, but it is more or less a copy of what you saw in the video but without recursion. First you have an array which holds the position which are given in the beginning. Then, you proceed filling in the board and every time you find out that you can't continue filling in the board you backtrack the i and j variables of the loop until you reach the next number which you filled in and continue trying filling it after setting number To Try to be 1+the previous numberToTry.

    • @mr.mirror1213
      @mr.mirror1213 Pƙed 2 lety +1

      iirc the whole problem is a system of linear equation , and u can solve it in O(n) if u use multigrid method

  • @danielmago4327
    @danielmago4327 Pƙed 2 lety

    amazing professor!

  • @mohammadsadrayeganehfaal2323

    such a enjoyable algorithm!!!

  • @jamesdepoorter726
    @jamesdepoorter726 Pƙed 2 lety +1

    Hello John, why didn't you use TDD in this example? This could be a nice addition, because it constantly keeps the code in check

  • @38YD
    @38YD Pƙed 2 lety +1

    love this!

  • @cptsalazar4986
    @cptsalazar4986 Pƙed 2 lety

    Awesome johnny...

  • @surjansr
    @surjansr Pƙed 2 lety +62

    Great explanation.
    Will be great if we can also talk about the time complexity of the solutions

    • @robertoborelli3275
      @robertoborelli3275 Pƙed 2 lety +11

      It's like O(k*10^(k^2 -n)) where k is the number of cells in a row and n is the number of placed numbers at the start.
      If you try with k greaters than 9 this algorithm would literally take years to find a solution.
      You can do better using sat solvers and translating the sudoko problem into cnf logical formulas.

    • @smrtfasizmu6161
      @smrtfasizmu6161 Pƙed 2 lety

      @@robertoborelli3275 may I ask why do you have zero in the beginning of the expression 0(k * 10^(k^2 - n))
      doesn't it just cancel everything to zero? Also, why do you have 10 to the power of cells to solve, how did you get 10? Did you mean k because with every added unsolved cell you need k times more traversing the loops (assuming that the number of rows = the number of digits you can fill a cell in) ? And why do you have k * in the beginning of the expression?

    • @robertoborelli3275
      @robertoborelli3275 Pƙed 2 lety +7

      @@smrtfasizmu6161 it's been a while since I've watched the video and now I don't remember exactly the code but here I give you some explanations:
      1) It's not a 0, but is a big O. This thing is called "Big O notation". Simplifying, you can read it as "the complexity is less or equal than..." but there are some formal and accurate mathematical definitions behind this intuition I gave.
      2) The intuition behind the formula is that this code is clearly exponential in the number of unsolved cells (k^2 - n).
      3) each time you call the function to see if a number is valid in cell you spend O(k) time.
      4) For each cell there are (exactly) k possible values (in the case of normal sudoku k is 9).
      So to sum the important thing here are:
      - exponential in the number of unsolved cells.
      - you take linear time in k, each time you check if a number is valid
      So as I wrote in the previous comment this is a pretty easy solution to write and implement but it's very inefficient since it uses the technique 'guess and verify'.
      It's much better (but also a bit more difficult) to use a sat solver for this kinds of problems.

    • @juanmalpartida1333
      @juanmalpartida1333 Pƙed 2 lety

      Time complexity looks to be O(n^3) worst case. Average, eyeballing it, I would say is n^2*log(n)

    • @robertoborelli3275
      @robertoborelli3275 Pƙed 2 lety +2

      ​@@juanmalpartida1333 no. just because you have 3 nested loops you can't always say that you have O(n^3).
      Inside this loop there is a recursion!
      This solution is exponential for sure, infact there are situations in which you guessed j correct values, than you are trying to fill the j+1-th value and you discover that there is no such a solution. In this case the algorithm does "backtracking" and there are situations in which all the j guessed valuesare wrong and the algorithm must re guess the entire solution.
      This leads to exponential cost!

  • @dipanshuasri
    @dipanshuasri Pƙed 11 dny

    Hi John, what should be the strategy to follow your tutorial. Shall we understand it first whole ? then we should code or should we code parallel ?

  • @manikandanm5567
    @manikandanm5567 Pƙed 2 lety

    This is cool, thanks man

  • @djneils100
    @djneils100 Pƙed 2 lety

    this is a quality tutorial

  • @codegeek8256
    @codegeek8256 Pƙed 2 lety

    Please make a video on the Hand Of Poker (Poker Hands) Game, it seems to be used alot on interview assessments this days. I am sure alot of people need it.

  • @shintaromidorima1552
    @shintaromidorima1552 Pƙed rokem

    it is 100% working teacher john and thank you for the source code

  • @user-jh9ut7in8i
    @user-jh9ut7in8i Pƙed 2 lety

    like your explain!!
    very clear!!!!!

  • @rakeshreddypallepati6845
    @rakeshreddypallepati6845 Pƙed 2 lety

    Awesome Explanation......does the time complexity is ignored here as we are looping for a constant no of elements

  • @rosa3709
    @rosa3709 Pƙed 2 lety

    Great explanation! Why did we return not(!) of the three methods in method isValidPlacement?

  • @lukaskock7020
    @lukaskock7020 Pƙed 2 lety

    Thank you very much!

  • @bartomiejpotaman6973
    @bartomiejpotaman6973 Pƙed 6 měsĂ­ci

    Shit took me a while but I think that's why it was worth it. This video made recursion seem so much more intuitive. Thank you!

  • @pascha4527
    @pascha4527 Pƙed 2 lety

    Its clever, I understood right away how it worked but the get to this simplicity is quite amazing. If it's you who found the solution then you're quite a clever man!
    Amazing work!

  • @jefersonlerma5743
    @jefersonlerma5743 Pƙed rokem +1

    Pretty nice explanation. I made one sudoku solver but try to improve his performance using a priotityQueue. Basically save in the queue the empty spaces that can take the minimun posible values, so.. the queue delivery the spaces that have less probablity to change... and i reorder the probability of the other spaces that have been afected for add a new number in ther matrix. This consume so much memory but less time...

    • @CodingWithJohn
      @CodingWithJohn  Pƙed rokem

      Interesting methodology! This definitely isn't the most efficient way to do it but the board is limited to 9x9, so even with a terrible time complexity any board is still solved pretty quickly